Subject: Re: [PATCH net-next] bonding: add software timestamping support

From: Miroslav Lichvar <[email-masked]>
Date: Mon, 3 Apr 2023 12:18:03 +0200

On Fri, Mar 31, 2023 at 11:32:03AM +0800, Hangbin Liu wrote:
> On Wed, Mar 29, 2023 at 09:12:44PM -0700, Jay Vosburgh wrote:
> > 	If I'm reading things correctly, the answer is no, as one
> > exception appears to be IPOIB, which doesn't define .get_ts_info that I
> > CAN Find, and does not call skb_tx_timestamp() in ipoib_start_xmit().
> 
> Oh.. I thought it's a software timestamp and all driver's should support it.
> I didn't expect that Infiniband doesn't support it. Based on this, it seems
> we can't even assume that all Ethernet drivers will support it, since a
> private driver may also not call skb_tx_timestamp() during transmit. Even if
> we check the slaves during ioctl call, we can't expect a later-joined slave
> to have SW TX timestamp support. It seems that we'll have to drop this feature."

I'd not see that as a problem. At the time of the ioctl call the
information is valid. I think knowing that some timestamps will be
missing due to an interface not supporting the feature is a different
case than the admin later adding a new interface to the bond and
breaking the condition. The application likely already have some
expectations after it starts and configures timestamping, e.g. that
the RX filter is not changed or TX timestamping disabled.

-- 
Miroslav Lichvar